<template>
  <article class="product-page">
    <div class="header">
      <div class="info">
        <h1 class="title">{{ product.title }}</h1>
        <h2 class="short-description">{{ product.shortDescription }}</h2>
        <div class="info__footer">
          <div class="price-info-container">
            <div class="price-container price-container--off" v-if="product.off">
              <p class="price price--off">{{ product.price | formatPrice }}</p>
              <p class="price-unit">تومان</p>
            </div>
            <div class="price-container">
              <p class="price">{{ getPrice | formatPrice }}</p>
              <p class="price-unit">تومان</p>
            </div>
          </div>
          <div class="labels">
            <Chip
              outline
              small
              class="sale-label"
              primary
              v-if="product.off"
              v-ripple="'rgba(230, 179, 30, 0.2)'"
            >
              <template #icon>
                <OfferIcon />
              </template>
              <div class="sale-label-text">٪{{product.off}} تخفیف</div>
            </Chip>
            <nuxt-link :to="`/shop/category/${product.category.id}`" v-if="product.category">
              <Chip class="category" small>
                <div class="category-text">{{ product.category.title }}</div>
              </Chip>
            </nuxt-link>
          </div>
        </div>
        <Button type="outlined" color="primary" class="cart-button" @click.native="addToCart">
          <template #icon>
            <CartIcon class="cart-button__icon"/>
          </template>
          افزودن به سبد خرید
        </Button>
      </div>
      <Gallery class="gallery" :images="product.pictures" v-if="product.pictures" />
    </div>
    <section class="body" v-html="product.description"></section>
  </article>
</template>

<script>
import numeral from "numeral";
import Chip from "@/components/base/Chip";
import OfferIcon from "@/assets/svgs/offer.svg";
import Button from "@/components/base/Button";
import CartIcon from "@/assets/svgs/cart.svg";
import Gallery from "@/components/catalog/Gallery"

export default {
  components: {
    Chip,
    OfferIcon,
    Button,
    CartIcon,
    Gallery
  },
  async asyncData(context) {
    let product = {};
    const id = context.route.params.id;
    await context.store.dispatch('shop/fetchProduct', id).then(response => {
      console.log(response.data.data);
      product = response.data.data;
    }).catch(error => {
      console.log("not found");
    });
    return {
      product
    }
  },
  computed: {
    getPrice() {
      return (this.product.price * (100 - this.product.off)) / 100;
    }
  },
  filters: {
    formatPrice(val) {
      return numeral(val).format("0,0");
    }
  },
  methods: {
    addToCart() {
      this.$store.dispatch('cart/push', this.product.id).then(response => {
        this.$store.dispatch('notifications/push', {
          type: 'success',
          light: true,
          message: 'به سبد خرید اضافه شد.'
        });
      }).catch(error => {
        if (error === "quantity") {
          this.$store.dispatch('notifications/push', {
            type: 'warning',
            light: true,
            message: 'در انبار موجود نمی باشد.'
          });
        } else {
          this.$router.push('/register');
        }
      });
    }
  },
  mounted() {
    this.$store.dispatch('settings/setBackRoute', '/shop');
    if (!this.product.id) throw new Error("Product not found");
  },
  beforeDestroy() {
    this.$store.dispatch('settings/setBackRoute', '');
  },
  head() {
    return {
      title: this.product.title
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.header
  display flex
  justify-content space-between
  @media only screen and (max-width: 1200px)
    flex-direction column

.gallery
  width  50%
  @media only screen and (max-width: 1200px)
    margin-top $lg
    width 100%
    min-height 37rem
  // @media only screen and (max-width: 1000px)
  //   margin-top $sm
  @media only screen and (max-width: 800px)
    min-height 35rem
  @media only screen and (max-width: 700px)
    min-height 40rem
    margin-top $xlg
  @media only screen and (max-width: 600px)
    min-height 30rem
    margin-top $xlg
.info
  width 40%
  @media only screen and (max-width: 1200px)
    width 100%
  &__footer
    display flex
    align-items center
    @media only screen and (max-width: 450px)
      flex-direction column

.labels
  @media only screen and (max-width: 450px)
    margin-top $sm
    align-self flex-end
  display flex
  align-items center

.title
  font-size $product-page-title-font-size
  font-weight 500
  color $white
  margin-bottom $sm

.short-description
  font-size $font-size
  color rgba($white, .5)
  margin-bottom $sm

.sale-label
  margin-left $sm

.price-container
  display flex
  color $white
  align-items center
  &--off
    color $primary
    opacity 0.5

.price
  font-size $font-size
  &--off
    text-decoration line-through

.price-unit
  font-size $font-size
  margin $product-price-unit-margin

.price-info-container
  margin-left auto

.cart-button
  margin-top $md
  width 100%
  direction ltr
  &__icon
    fill $primary

.body
  margin-top $xxlg
  @media only screen and (max-width: 800px)
    margin-top $lg
  color $white
  direction rtl
  & >>> h2
    margin-bottom $md
    font-weight 300
    font-size  $product-page-title-font-size
  & >>> p
    &:not(:last-child)
      margin-bottom $md
    line-height $prodcut-page-description-line-height
  & >>> img 
    width 80%
    display block
    margin $xlg auto
    @media only screen and (max-width: 700px)
      width 100%
</style>